/**
 * icon.service.ts
 * 
 * Service that registers all custom icons with the MatIconRegistry.
 * 
 * author: Anne Naumann
 * last edit / by: 2021-05-25 / Anne Naumann
 */
import { Injectable } from '@angular/core';
import { MatIconRegistry } from "@angular/material/icon";
import { DomSanitizer } from "@angular/platform-browser";
import { Icons } from './icons'

@Injectable({
  providedIn: 'root'
})
export class IconService {

  constructor(private matIconRegistry: MatIconRegistry, 
              private domSanitizer: DomSanitizer) {}

  public registerIcons() : void{
    this.loadIcons(Object.values(Icons), '../assets/images')
  }

  private loadIcons(iconKeys: string[], iconUrl: string): void {
    iconKeys.forEach(key => {
      this.matIconRegistry.addSvgIcon(key, this.domSanitizer.bypassSecurityTrustResourceUrl(`${iconUrl}/${key}.svg`));
    });
  }
}
